local ClassType = class("ImageNumber", function (...) return ccui.Layout:create() end)

ClassType.ALIGNMENT_LEFT = 0
ClassType.ALIGNMENT_MID = 1
ClassType.ALIGNMENT_RIGHT = 2

function ClassType:ctor(imageString, imageType, bitNum, size, alignment)
    self.imageString = imageString
    self.imageType = imageType
    self.bitNum = bitNum
    self.size = size
    self.alignment = alignment
    self:setContentSize(size)
    self:setAnchorPoint(cc.p(0,0.5))
    self.NumberArray = {}
    self.step = self.size.width/(self.bitNum+1)
    self.number = 99
    for i=1, self.bitNum do
        local string = self.imageString..i
        local NumberImage = ccui.ImageView:create()
        self.NumberArray[#self.NumberArray+1] = NumberImage
        local pos = cc.p(self.step*i, self.size.height/2)
        NumberImage:setPosition(pos)
        self:addChild(NumberImage)
    end
    local realBit = self:calculateBit(self.number)
    self:updateNum(self.number)
end

function ClassType:updateNum(number)
    self.number = number
    local realBit = self:calculateBit(self.number)
    if realBit>self.bitNum then
        print("The bit of the number is too long!")
        return
    end
    for i=1, self.bitNum do
        self.NumberArray[i]:setVisible(false)
    end
    if self.alignment==self.ALIGNMENT_LEFT then
        for i=1, realBit do
            local exponent = realBit-i
            local tempNumber = math.floor(number/(10^exponent))
            number = number%(10^exponent)
            
            self.NumberArray[i]:setVisible(true)
            self.NumberArray[i]:loadTexture(_RR(self.imageString..tempNumber..".png"), self.imageType)
        end
    elseif self.alignment==self.ALIGNMENT_RIGHT then
        for i=1, realBit do
            local tempNumber = number%10
            number = math.floor(number/10) 
            
            self.NumberArray[self.bitNum-(i-1)]:setVisible(true)
            self.NumberArray[self.bitNum-(i-1)]:loadTexture(_RR(self.imageString..tempNumber), self.imageType)
        end
    elseif self.alignment==self.ALIGNMENT_MID then
        local delta = self.bitNum - realBit
        local index = math.floor(delta/2)
        for i=1, realBit do
            local exponent = realBit-i
            local tempNumber = math.floor(number/(10^exponent))
            number = number%(10^exponent)

            self.NumberArray[i+index]:setVisible(true)
            self.NumberArray[i+index]:loadTexture(_RR(self.imageString..tempNumber), self.imageType)
        end
    end
end

function ClassType:calculateBit(number)
    if number==0 then
        return 1
    end

    local bit = 0
    while number~=0 do
        number = math.floor(number/10)
        bit = bit + 1
    end
    return bit
end

ImageNumber = ImageNumber or ClassType