
--[[
替换html的特殊字符串
--]]
function string.htmlspecialchars(input)
    for k, v in pairs(string._htmlspecialchars_set) do
        input = string.gsub(input, k, v)
    end
    return input
end
string._htmlspecialchars_set = {}
string._htmlspecialchars_set["&"] = "&amp;"
string._htmlspecialchars_set["\""] = "&quot;"
string._htmlspecialchars_set["'"] = "&#039;"
string._htmlspecialchars_set["<"] = "&lt;"
string._htmlspecialchars_set[">"] = "&gt;"


--[[
反向替换html的特殊字符串
--]]
function string.htmlspecialcharsDecode(input)
    for k, v in pairs(string._htmlspecialchars_set) do
        input = string.gsub(input, v, k)
    end
    return input
end

function string.filter(input)

    if gstrFilterc ==nil then
        gstrFilterc = {}        
        local kw = GameData.KeyWordRef
        --for i = 1,#kw do
        for k,v in pairs(kw) do
           local line = v 
           table.insert(gstrFilterc,line)
        end
    end

    local res=input
	local haveReplace = false
    for i,v in ipairs(gstrFilterc) do
        local num = 0
		res, num =string.gsub(res,v,"*")
		if haveReplace == false and num > 0 then
			haveReplace = true
		end
        --LOG_ERROR("hihihihi","%s",res)
    end
    return res, haveReplace

    
    --if gstrFilterc ==nil then
    --    gstrFilterc = {}
    --    gstrFiltere = {}

    --    loadLuaFile("Config/KeyWordRef")
    --    local kw = GameData.KeyWordRef
    --    for i = 1,#kw do
    --       local line = kw[i] 
    --       firstAscNum = 0 +string.byte(line, 1)
    --       --判断第一个字母是英文还是中文
    --       if (firstAscNum >=65 and  firstAscNum <=90) or (firstAscNum >=97 and  firstAscNum <=122) then
    --            gstrFiltere[line] = "***"
    --       else
    --            gstrFilterc[line] = "***"
    --       end

    --    end
    --end

    

    --local res=string.gsub(input, "([\xA1-\xF7][\xA1-\xF7\xA1-\xFE]+)", gstrFilterc)
    --local retstr=string.gsub(res, "(%w+)",gstrFiltere )
    
    --return retstr
    

end


--[[
替换html的字符串
换行符\n换成<br />
--]]
function string.nl2br(input)
    return string.gsub(input, "\n", "<br />")
end

function string.str2Asc(input)
    local ascNum = 0
    for i=1,#input do
        ascNum = ascNum +string.byte(input, i)
    end
  return  ascNum
end

function string.numToCtxt(input)
	local ref = _TT(2161)
	local refdata = string.split(ref,":")
	local returnstr = nil
	local firstNum = math.modf(input/10)
	local secondNum = input%10
	local firststr =nil
	
	if firstNum ~= 0 then
		firststr = refdata[firstNum + 1]
	end
	if firststr == nil then
		firststr = ""
		
	end
	returnstr = firststr
	if returnstr ~= "" then
		if firstNum == 1 then
			returnstr = ""
		end
		if secondNum~=0 then
			returnstr = returnstr..refdata[1]
			local secondstr =refdata[secondNum + 1]
			returnstr = returnstr..secondstr
		else
			returnstr = returnstr..refdata[1]
		end
	else
		returnstr = refdata[secondNum + 1]
	end
    return returnstr
end

--[[
普通文本转成html格式
--]]
function string.text2html(input)
    input = string.gsub(input, "\t", "    ")
    input = string.htmlspecialchars(input)
    input = string.gsub(input, " ", "&nbsp;")
    input = string.nl2br(input)
    return input
end

--[[
分隔字符串，返回分隔后的table
str:(string) 分隔字符串
delimiter:(string) 分隔符
--]]
function string.split(str, delimiter)
    str = tostring(str)
    delimiter = tostring(delimiter)
    if (delimiter=='') then return false end
    local pos,arr = 0, {}
    -- for each divider found
    for st,sp in function() return string.find(str, delimiter, pos, true) end do
        table.insert(arr, string.sub(str, pos, st - 1))
        pos = sp + 1
    end
    table.insert(arr, string.sub(str, pos))
    return arr
end

--[[
去左边的空白符
--]]
function string.ltrim(str)
    return string.gsub(str, "^[ \t\n\r]+", "")
end

--[[
去右边的空白符
--]]
function string.rtrim(str)
    return string.gsub(str, "[ \t\n\r]+$", "")
end

--[[
去右边的指定字符串
--]]
function string.rtrimC(str,c)
    return string.gsub(str, "["..c.."]+$", "")
end

--[[去掉所有空格--]]
 function string.Atrim(str)
	if str == nil then
	   return nil, "the string parameter is nil"
	end
	str = string.gsub(str, " ", "")
	return str
end
--[[
去两边的空白符
--]]
function string.trim(str)
    str = string.gsub(str, "^[ \t\n\r]+", "")
    return string.gsub(str, "[ \t\n\r]+$", "")
end

--[[
首字母大写
--]]
function string.ucfirst(str)
    return string.upper(string.sub(str, 1, 1)) .. string.sub(str, 2)
end

local function urlencodeChar(char)
    return "%" .. string.format("%02X", string.byte(char))
end

--[[
转成url编码
--]]
function string.urlencode(str)
    -- convert line endings
    str = string.gsub(tostring(str), "\n", "\r\n")
    -- escape all characters but alphanumeric, '.' and '-'
    str = string.gsub(str, "([^%w%.%- ])", urlencodeChar)
    -- convert spaces to "+" symbols
    return string.gsub(str, " ", "+")
end

--[[
把url解码
--]]
function string.urldecode(str)
    str = string.gsub (str, "+", " ")
    str = string.gsub (str, "%%(%x%x)", function(h) return string.char(tonum(h,16)) end)
    str = string.gsub (str, "\r\n", "\n")
    return str
end

--[[
返回中文长度,1个中文算2个字符,1个英文算1个字符.
--]]
function string.cn2len(str)
	if( str == nil ) then
		return 0;
	end
	local len = string.utf8len2(str)
	if len == nil then
		len = string.len(str)
	end	
	return len
end

--[[
返回utf8的长度,1个中文算1个字符,1个英文也算1个字符.
--]]
function string.utf8len(str)
    local len  = #str
    local left = len
    local cnt  = 0
    local arr  = {0, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc}
    while left ~= 0 do
        local tmp = string.byte(str, -left)
		if tmp == nil then
			cnt = nil
			break
		end
        local i   = #arr
        while arr[i] do
            if tmp >= arr[i] then
                left = left - i
                break
            end
            i = i - 1
        end
        cnt = cnt + 1
    end
    return cnt
end

--[[
返回utf8的长度,1个中文算2个字符,1个英文也算1个字符.
--]]
function string.utf8len2(str)
    local len  = #str
    local left = len
    local cnt  = 0
    local arr  = {0, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc}
    while left ~= 0 do
        local tmp = string.byte(str, -left)
		if tmp == nil then
			return 0			
		end
        local i   = #arr
        while arr[i] do
            if tmp >= arr[i] then
                left = left - i				
				if i > 2 then
					cnt = cnt + 1
				end				
                break
            end
            i = i - 1			
        end
        cnt = cnt + 1
    end
    return cnt
end

--[[
数字转成千分位输出的字符串
--]]
function string.formatNumberThousands(num)
    local formatted = tostring(tonum(num))
    local k
    while true do
        formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
        if k == 0 then break end
    end
    return formatted
end

--[[
数字转成带K单位的字符串 125843 => 12K
--]]
function string.formatNumberBy2K(num)
	local bNegative = false
	local divider = 1
	local unit = nil
	if num < 0 then
		num = num * -1
		bNegative = true
	end
	if num > 999999999 then
		divider = 1000000000
		unit = "G"
	elseif num > 999999 then
		divider = 1000000
		unit = "M"
	elseif num > 999 then
		divider = 1000
		unit = "K"
	else 
		if bNegative then
			return string.format("%d", num*-1)
		end
		return string.format("%d", num)
	end
	
	local value = num/divider
	local ivalue = math.round(value);
	if( ivalue <= 0 ) then
		ivalue = 1;
	end
	if bNegative then		
		return string.format("%d"..unit, ivalue*-1)
	end
	return string.format("%d"..unit, ivalue)
end
--[[
数字转成带K单位的字符串 125843 => 12.5K
--]]
function string.formatNumberByK(num,trunc)
    if not type(num)=="number" then
        LOG_ERROR("formatNumberByk","num must be number")
        return 
    end
	local bNegative = false
	local divider = 1
	local unit = nil
	if num < 0 then
		num = num * -1
		bNegative = true
	end
	
	if num > 999999999 then
		divider = 1000000000
		unit = "G"
	elseif num > 999999 then
		divider = 1000000
		unit = "M"
	elseif num > 999 then
		divider = 1000
		unit = "K"
	else 
		if bNegative then
			return string.format("%d", num*-1)
		end
		return string.format("%d", num)
	end
	--[[
	local num1 = math.modf(num/divider)
	num = num - num1*divider
	divider = divider / 10
	local num2 = math.modf(num/divider)
	num = num - num2*divider
	divider = divider / 10
	local num3 = math.modf(num/divider)
	--]]
	local value = num/divider
	if bNegative then		
		if value >= 100 then
		local ivalue = math.round(value)
			return string.format("%d"..unit, ivalue*-1)
		elseif value >= 10 then
			return string.format("%.1f"..unit, value*-1)
		else
			return string.format("%.2f"..unit, value*-1)
		end	
	end
	if value >= 100 then
		local ivalue = math.round(value)
		return string.format("%d"..unit, ivalue)
	elseif value >= 10 then
        if trunc ~= nil then
            value = value - value%0.1
        end
		return string.format("%.1f"..unit, value)
	else
        if trunc ~= nil then
            value = value - value%0.01
        end
		return string.format("%.2f"..unit, value)
	end	
end



--[[
时间格式
time:秒
--]]
function string.formatNumberByTime(time)
	local h = math.modf(time/3600)
	local time1 = time - h*3600
	local m = math.modf(time1/60.0)
	local s = time%60
	return string.format("%dh%dm%ds",h,m,s)
end

--[[
时间格式
time:秒
--]]
--跟上一个函数相同，但是只显示2位,如果有小时就显示1h30m如果没小时，就显示30m5s
function string.formatNumberByTime2(time)
	local h = math.modf(time/3600)
	local time1 = time - h*3600
	local m = math.modf(time1/60.0)
	local s = time%60
	if h == 0 then
		return string.format("%dm%ds",m,s)
	else
		return string.format("%dh%dm",h,m)
	end
end
--[[
时间格式
只返回数字不添加H-M-S格式
--]]
function string.formatNumberByTime3(time)
    local day = math.modf(time/86400)
    local time0 = time-day*86400
	local h = math.modf(time0/3600)
	local time1 = time0 - h*3600
	local m = math.modf(time1/60.0)
    local time2 = time1 - m*60
    local s = time2
	--local s = time%60
		return day,h,m,s
end

--[[
判断是否是浮点型
参数：数值或者字符串
--]]
function string.isFloat(num)
	local baseNum = tonumber(num)
	local intNum = math.floor(tonumber(num))
	if baseNum ~= intNum then
		return true
	end
	return false
end

--获取路径
function string.stripfilename(filename)
	local ret = string.match(filename, "(.+)/[^/]*%.%w+$") --*nix system
	--return string.match(filename, “(.+)\\[^\\]*%.%w+$”) — windows
	if ret == nil then
		ret = filename
	end
    return ret
    
end

--获取文件名
function string.strippath(filename)
    local ret = string.match(filename, ".+/([^/]*%.%w+)$") -- *nix system
    --return string.match(filename, “.+\\([^\\]*%.%w+)$”) — *nix system
	if ret == nil then
		ret = filename
	end
    return ret
end

--去除扩展名
function string.stripextension(filename)
    local idx = filename:match(".+()%.%w+$")
    if(idx) then
        return filename:sub(1, idx-1)
    else
        return filename
    end
end

--获取扩展名
function string.getextension(filename)
    return filename:match(".+%.(%w+)$")	
end

-- c3b转html color
function string.c3bToHtmlColor(c3b)
	local r = string.format("%02x",c3b.r)
	local g = string.format("%02x",c3b.g)
	local b = string.format("%02x",c3b.b)
	return "#"..r..g..b
end


--[[
在这项目里，这里坚决不再改，再改请让相关策划吃西
--]]
--sName:要切割的字符串
--nShowCount：显示英文字个数，中文字为2的倍数,可为空
--函数实现：截取字符串一部分，剩余用“...”替换
function string.getShortName(sName,nShowCount)
    if sName == nil then
        return ""
    end
    local sStr = sName
    local tCode = {}
    local tName = {}
    local nLenInByte = #sStr
    local nWidth = 0
    if nShowCount == nil then
        nShowCount = 12--6个中文
        if GameConfig.Language == "ru" then
            nShowCount = 24
        end       
    end
    if GameConfig.Test_LongName == true then
        nShowCount = 4;
    end
	if nShowCount >= #sName then
		return sName;
	end
    for i=1,nLenInByte do
        local curByte = string.byte(sStr, i)
        local byteCount = 0;
        if curByte>0 and curByte<=127 then
            byteCount = 1
        elseif curByte>=192 and curByte<223 then
            byteCount = 2
        elseif curByte>=224 and curByte<239 then
            byteCount = 3
        elseif curByte>=240 and curByte<=247 then
            byteCount = 4
        end
        local char = nil
        if byteCount > 0 then
            char = string.sub(sStr, i, i+byteCount-1)
            i = i + byteCount -1
        end
        if byteCount == 1 then
            nWidth = nWidth + 1
            table.insert(tName,char)
            table.insert(tCode,1)
            
        elseif byteCount > 1 then
            nWidth = nWidth + 2
            table.insert(tName,char)
            table.insert(tCode,2)
        end
    end
    
    if nWidth > nShowCount then
        local _sN = ""
        local _len = 0
        for i=1,#tName do
            _sN = _sN .. tName[i]
            _len = _len + tCode[i]
            if _len >= nShowCount-2 then--4个中文
                break
            end
        end
        sName = _sN .. "..."
    end
    return sName
end